<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 26.10 Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="text-center">Danh sách đơn hàng</h2>
                <table class="table text-center table-striped" id="table-order">
                    <thead>
                        <tr>
                            <th scope="col">Order Code</th>
                            <th scope="col">Kích cỡ combo</th>
                            <th scope="col">Loại pizza</th>
                            <th scope="col">Nước uống</th>
                            <th scope="col">Thành tiền</th>
                            <th scope="col">Họ và tên</th>
                            <th scope="col">Số điện thoại</th>
                            <th scope="col">Trạng thái</th>
                            <th scope="col">Chi tiết</th>
                        </tr>
                    </thead>
                    <tbody id="table-body">

                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gEND_OF_ROW_COL = -1;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
             /**
            * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
            */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log("Bắt đầu load data...");
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            var vOrderList = paramXMLHttpAllOrder.responseText;
            console.log("Danh sách order: " + vOrderList);
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            var vOrderListObj = JSON.parse(vOrderList);
            var vTableOrder = document.getElementById("table-order");
            var vTableBody = vTableOrder.getElementsByTagName("tbody")[0];   
            //xóa bảng
            vTableBody.innerHTML = "";
            //thêm dòng và dữ liệu cho từng dòng
            for (var bI = 0; bI <vOrderListObj.length; bI++){
            //thêm 1 dòng mới và gắn vào table
            var bNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
            //thêm 9 ô trên dòng
            var bOrderCodeCell = bNewRow.insertCell(0);
            var bComboCell = bNewRow.insertCell(1);
            var bPizzaCell = bNewRow.insertCell(2);
            var bDrinkCell = bNewRow.insertCell(3);
            var bPiceCell = bNewRow.insertCell(4);
            var bNameCell = bNewRow.insertCell(5);
            var bPhoneCell = bNewRow.insertCell(6);
            var bStatusCell = bNewRow.insertCell(7);
            var bDetailCell = bNewRow.insertCell(8);

            //điền dữ liệu cho từng ô
            bOrderCodeCell.innerHTML = vOrderListObj[bI].orderCode;
            bComboCell.innerHTML = vOrderListObj[bI].kichCo;
            bPizzaCell.innerHTML = vOrderListObj[bI].loaiPizza;
            bDrinkCell.innerHTML = vOrderListObj[bI].idLoaiNuocUong;
            bPiceCell.innerHTML = vOrderListObj[bI].thanhTien;
            bNameCell.innerHTML = vOrderListObj[bI].hoTen;
            bPhoneCell.innerHTML = vOrderListObj[bI].soDienThoai;
            bStatusCell.innerHTML = vOrderListObj[bI].trangThai;
            var vButtonChiTiet = document.createElement("button"); //khai báo biến tạo nút và định dạng
            vButtonChiTiet.className = "btn btn-info";
            vButtonChiTiet.innerHTML = "Chi tiết";
            bDetailCell.appendChild(vButtonChiTiet); //thêm nút
            //gán dữ liệu vào dataset của button
            var bOrderId = vOrderListObj[bI].id;
            var bOrderCode = vOrderListObj[bI].orderCode;
            vButtonChiTiet.setAttribute("id", bOrderId);
            vButtonChiTiet.setAttribute("order-code", bOrderCode);
            vButtonChiTiet.setAttribute("onclick", "onBtnChiTietClick(this)"); //thêm sự kiện onclick            
        }
        }
        //khai báo hàm click nút chi tiết
        function onBtnChiTietClick(vButtonChiTiet){
            var vId = vButtonChiTiet.getAttribute("id");
            var vOrderCode = vButtonChiTiet.getAttribute("order-code");
            console.log("Order Id: " + vId);
            console.log("Order Code: " + vOrderCode);
            //gọi form orderDetail hiển thị chi tiết order
            const vDETAIL_FORM_URL = "orderDetail.html";
            var vUrlSiteToOpen = vDETAIL_FORM_URL + "?" +
            "id=" + vId +
            "&orderCode=" + vOrderCode;
            window.location.href = vUrlSiteToOpen;
        }
    </script>
</body>

</html>